DELIMITER $$
CREATE OR REPLACE PROCEDURE `S_LOOPING_New_RankedPickList`()
BEGIN
DECLARE vStart_Cnt BIGINT DEFAULT 0;
DECLARE vEnd_Cnt BIGINT;
DECLARE vBatchSize bigint DEFAULT 100000;

SELECT Customer_Id INTO vStart_Cnt FROM RankedPickList ORDER BY Customer_Id ASC LIMIT 1;
SELECT Customer_Id INTO @Rec_Cnt FROM RankedPickList ORDER BY Customer_Id DESC LIMIT 1;



DROP Table if exists RankedPickListNew;
create  TABLE `RankedPickListNew` (
 `Customer_Id` bigint(20) DEFAULT NULL,
  `Product_Id` bigint(20) DEFAULT NULL,
  `Hybridizer_Rank` tinyint(3) DEFAULT NULL,
  `GENOME` char(1) DEFAULT NULL,
  `NN` char(1) DEFAULT NULL,
  `IBCF` char(1) DEFAULT NULL,
  `PREFERENCE` char(1) DEFAULT NULL,
  `TRENDING` char(1) DEFAULT NULL,
  `TRENDINGSTLY` char(1) DEFAULT NULL,
  `CART_GENOME` char(1) DEFAULT NULL,
  `CART_NN` char(1) DEFAULT NULL,
  `CART_IBCF` char(1) DEFAULT NULL,
  `CART_PREFERENCE` char(1) DEFAULT NULL,
  `CART_TRENDING` char(1) DEFAULT NULL,
  `CART_TRENDINGSTLY` char(1) DEFAULT NULL,
  `WSHL_GENOME` char(1) DEFAULT NULL,
  `WSHL_NN` char(1) DEFAULT NULL,
  `WSHL_IBCF` char(1) DEFAULT NULL,
  `WSHL_PREFERENCE` char(1) DEFAULT NULL,
  `WSHL_TRENDING` char(1) DEFAULT NULL,
  `WSHL_TRENDINGSTLY` char(1) DEFAULT NULL,
  `RecoGenDate` date DEFAULT NULL,
  `Modified_Date` DATETIME DEFAULT CURRENT_TIMESTAMP,
  `ObsEndDate` date DEFAULT NULL,
  `Algo` char(40) DEFAULT NULL,
  KEY `Customer_Id` (`Customer_Id`),
  KEY `Product_Id` (`Product_Id`),
  KEY `Hybridizer_Rank` (`Hybridizer_Rank`),
  KEY `GENOME` (`GENOME`),
  KEY `NN` (`NN`),
  KEY `IBCF` (`IBCF`),
  KEY `PREFERENCE` (`PREFERENCE`),
  KEY `TRENDING` (`TRENDING`),
  KEY `TRENDINGSTLY` (`TRENDINGSTLY`),
  KEY `CART_GENOME` (`CART_GENOME`),
  KEY `CART_NN` (`CART_NN`),
  KEY `CART_IBCF` (`CART_IBCF`),
  KEY `CART_PREFERENCE` (`CART_PREFERENCE`),
  KEY `CART_TRENDING` (`CART_TRENDING`),
  KEY `CART_TRENDINGSTLY` (`CART_TRENDINGSTLY`),
  KEY `WSHL_GENOME` (`WSHL_GENOME`),
  KEY `WSHL_NN` (`WSHL_NN`),
  KEY `WSHL_IBCF` (`WSHL_IBCF`),
  KEY `WSHL_PREFERENCE` (`WSHL_PREFERENCE`),
  KEY `WSHL_TRENDING` (`WSHL_TRENDING`),
  KEY `WSHL_TRENDINGSTLY` (`WSHL_TRENDINGSTLY`),
  KEY `RecoGenDate` (`RecoGenDate`),
  KEY `Modified_Date` (`Modified_Date`),
  KEY `ObsEndDate` (`ObsEndDate`),
  KEY `Algo` (`Algo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1
 PARTITION BY RANGE (`Customer_Id`)
(PARTITION `p1` VALUES LESS THAN (1000000) ENGINE = InnoDB,
 PARTITION `p2` VALUES LESS THAN (2000000) ENGINE = InnoDB,
 PARTITION `p3` VALUES LESS THAN (3000000) ENGINE = InnoDB,
 PARTITION `p4` VALUES LESS THAN (4000000) ENGINE = InnoDB,
 PARTITION `p5` VALUES LESS THAN (5000000) ENGINE = InnoDB,
 PARTITION `p6` VALUES LESS THAN (6000000) ENGINE = InnoDB,
 PARTITION `p7` VALUES LESS THAN (7000000) ENGINE = InnoDB,
 PARTITION `p8` VALUES LESS THAN (8000000) ENGINE = InnoDB,
 PARTITION `p9` VALUES LESS THAN (9000000) ENGINE = InnoDB,
 PARTITION `p10` VALUES LESS THAN (10000000) ENGINE = InnoDB,
 PARTITION `p11` VALUES LESS THAN (11000000) ENGINE = InnoDB,
 PARTITION `p12` VALUES LESS THAN (12000000) ENGINE = InnoDB,
 PARTITION `p13` VALUES LESS THAN (13000000) ENGINE = InnoDB,
 PARTITION `p14` VALUES LESS THAN (14000000) ENGINE = InnoDB,
 PARTITION `p15` VALUES LESS THAN (15000000) ENGINE = InnoDB,
 PARTITION `p16` VALUES LESS THAN (16000000) ENGINE = InnoDB,
 PARTITION `p17` VALUES LESS THAN (17000000) ENGINE = InnoDB,
 PARTITION `p18` VALUES LESS THAN (18000000) ENGINE = InnoDB,
 PARTITION `p19` VALUES LESS THAN (19000000) ENGINE = InnoDB,
 PARTITION `p20` VALUES LESS THAN (20000000) ENGINE = InnoDB,
 PARTITION `p21` VALUES LESS THAN (21000000) ENGINE = InnoDB,
 PARTITION `p22` VALUES LESS THAN (22000000) ENGINE = InnoDB,
 PARTITION `p23` VALUES LESS THAN (23000000) ENGINE = InnoDB,
 PARTITION `p24` VALUES LESS THAN (24000000) ENGINE = InnoDB,
 PARTITION `p25` VALUES LESS THAN (25000000) ENGINE = InnoDB,
 PARTITION `p26` VALUES LESS THAN (26000000) ENGINE = InnoDB,
 PARTITION `p27` VALUES LESS THAN (27000000) ENGINE = InnoDB,
 PARTITION `p28` VALUES LESS THAN (28000000) ENGINE = InnoDB,
 PARTITION `p29` VALUES LESS THAN (29000000) ENGINE = InnoDB,
 PARTITION `p30` VALUES LESS THAN (30000000) ENGINE = InnoDB,
 PARTITION `p31` VALUES LESS THAN (31000000) ENGINE = InnoDB,
 PARTITION `p32` VALUES LESS THAN (32000000) ENGINE = InnoDB,
 PARTITION `p33` VALUES LESS THAN (33000000) ENGINE = InnoDB,
 PARTITION `p34` VALUES LESS THAN (34000000) ENGINE = InnoDB,
 PARTITION `p35` VALUES LESS THAN (35000000) ENGINE = InnoDB,
 PARTITION `p36` VALUES LESS THAN (36000000) ENGINE = InnoDB,
 PARTITION `p37` VALUES LESS THAN (37000000) ENGINE = InnoDB,
 PARTITION `p38` VALUES LESS THAN (38000000) ENGINE = InnoDB,
 PARTITION `p39` VALUES LESS THAN (39000000) ENGINE = InnoDB,
 PARTITION `p40` VALUES LESS THAN (40000000) ENGINE = InnoDB,
 PARTITION `p100` VALUES LESS THAN MAXVALUE ENGINE = InnoDB);


PROCESS_LOOP: LOOP
SET vEnd_Cnt = vStart_Cnt + vBatchSize;
insert into RankedPickListNew(Customer_Id,Product_Id,Hybridizer_Rank,GENOME,NN,IBCF,PREFERENCE,TRENDING,TRENDINGSTLY,RecoGenDate,Modified_Date,ObsEndDate,Algo) 
select Customer_Id,Product_Id,Hybridizer_Rank,GENOME,NN,IBCF,PREFERENCE,TRENDING,TRENDINGSTLY,RecoGenDate,Modified_Date,ObsEndDate,Algo
from RankedPickList where Customer_Id between vStart_Cnt and vEnd_Cnt; 
SET vStart_Cnt = vEnd_Cnt;

IF vStart_Cnt  >= @Rec_Cnt THEN
	LEAVE PROCESS_LOOP;
END IF;        
END LOOP PROCESS_LOOP;  
DROP TABLE RankedPickList;
RENAME TABLE RankedPickListNew to RankedPickList;
END$$
DELIMITER ;
